(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     64136,       1541]
NotebookOptionsPosition[     63091,       1500]
NotebookOutlinePosition[     63451,       1516]
CellTagsIndexPosition[     63408,       1513]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Model Hotspots Cali", "Section",
 CellChangeTimes->{{3.6481487078741407`*^9, 3.648148718721486*^9}}],

Cell[CellGroupData[{

Cell["Importing the map of the streets of Cali", "Subsection",
 CellChangeTimes->{{3.648148735106998*^9, 3.648148740936943*^9}, {
  3.648148867192623*^9, 3.648148869472595*^9}, {3.6481489035790577`*^9, 
  3.648148913610845*^9}, {3.6502183169003963`*^9, 3.650218318149145*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "This", " ", "code", " ", "imports", " ", "and", " ", "draws", " ", "the",
      " ", "streets", " ", "of", " ", 
     RowBox[{"Cali", ".", " ", "We"}], " ", "only", " ", "take", " ", "into", 
     " ", "account", " ", "the", " ", "streets", " ", "of", " ", 
     RowBox[{"type", ":", "\"\<Via Arteria Principal\>\""}]}], ",", " ", 
    RowBox[{"\"\<Via Arteria Secundaria\>\"", " ", "and", " ", 
     RowBox[{"\"\<Via Colectora\>\"", ".", " ", "The"}], " ", "variable", " ",
      "mapa", " ", "is", " ", "a", " ", "image", " ", "of", " ", "Cali", " ", 
     "with", " ", "its", " ", "principal", " ", 
     RowBox[{"streets", ".", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"execution", " ", "time"}], "=", 
        RowBox[{"45", " ", "segs"}]}], ")"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", "\"\<Global`*\>\"", "]"}], " ", 
   RowBox[{"(*", 
    RowBox[{"erase", " ", "all", " ", "variables"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetDirectory", "@", 
     RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "set", " ", "working", " ", "directory", " ", "equal", " ", "to", " ", 
     "the", " ", "notebook", " ", "directory"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y", "=", 
     RowBox[{
      RowBox[{"Lookup", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"\"\<roadHierarchy.zip\>\"", ",", "\"\<Data\>\""}], "]"}], 
        ",", "\"\<Geometry\>\""}], "]"}], "\[LeftDoubleBracket]", "1", 
      "\[RightDoubleBracket]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"import", " ", "the", " ", "roads", " ", "of", " ", "Cali"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y1", "=", 
     RowBox[{
      RowBox[{"Lookup", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"\"\<BoundCali.zip\>\"", ",", "\"\<Data\>\""}], "]"}], ",", 
        "\"\<Geometry\>\""}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Import", "[", 
      RowBox[{"\"\<roadHierarchy.zip\>\"", ",", "\"\<SpatialRange\>\""}], 
      "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "import", " ", "the", " ", "bound", " ", "of", " ", "the", " ", "map"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"GeoPosition", "[", 
         RowBox[{
         "grid", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         "]"}], "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
       RowBox[{
        RowBox[{"GeoPosition", "[", 
         RowBox[{
         "grid", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
         "]"}], "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"grid", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"grid", "\[LeftDoubleBracket]", 
          RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"grid", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"grid", "\[LeftDoubleBracket]", 
          RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]}], "}"}]}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"typestreet", "=", 
     RowBox[{"Lookup", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Lookup", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{"\"\<roadHierarchy.zip\>\"", ",", "\"\<Data\>\""}], "]"}], 
          ",", "\"\<LabeledData\>\""}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<tipo_via\>\""}], "]"}]}], 
    ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"import", " ", "varios", " ", "types", " ", "of", " ", "roads"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "steet", " ", "types", " ", "are", " ", "described", " ", 
     RowBox[{"by", ":", " ", 
      RowBox[{"Union", "[", "typestreet", "]"}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "consider", " ", "only", " ", "streets", " ", "that", " ", "are", " ", 
      "cathegorized", " ", "as", " ", "\"\<Via Arterial Principal\>\""}], ",",
      " ", "\"\<Via Arterial Secundaria\>\"", ",", " ", 
     RowBox[{"and", " ", "\"\<Via Colectora\>\""}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"principalstreets", "=", 
     RowBox[{"Union", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"typestreet", ",", "\"\<Via Arteria Principal\>\""}], "]"}], 
        "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"typestreet", ",", "\"\<Via Arteria Secundaria\>\""}], "]"}],
         "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"typestreet", ",", "\"\<Via Colectora\>\""}], "]"}], "]"}]}],
       "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lista", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"y", "\[LeftDoubleBracket]", 
        RowBox[{"k", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "principalstreets"}], "}"}]}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "Lista", " ", "holds", " ", "the", " ", "line", " ", "coordinates", " ", 
     "that", " ", "describe", " ", "the", " ", "principal", " ", "streets"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mapa", "=", 
     RowBox[{"GeoGraphics", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"GeoPath", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
        "Lista"}], ",", 
       RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
       RowBox[{"GeoBackground", "\[Rule]", "None"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "generate", " ", "street", " ", "map", " ", "based", " ", "on", " ", 
     "Lista"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mapa1", "=", 
     RowBox[{"Binarize", "[", 
      RowBox[{"ColorNegate", "[", "mapa", "]"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6416615380054197`*^9, 3.641661562378059*^9}, {
   3.641661686530097*^9, 3.641661697703001*^9}, {3.641662361319675*^9, 
   3.641662395715398*^9}, {3.641665703981559*^9, 3.641665718114654*^9}, {
   3.641674678510166*^9, 3.641674685595119*^9}, {3.6417258109878902`*^9, 
   3.64172586022943*^9}, 3.641725944937023*^9, {3.641726106755786*^9, 
   3.641726106886526*^9}, {3.641726165682076*^9, 3.6417261689922323`*^9}, {
   3.641734613883419*^9, 3.641734614763386*^9}, {3.641734675837044*^9, 
   3.641734784850563*^9}, {3.641734867044142*^9, 3.6417348727885323`*^9}, {
   3.641734905431713*^9, 3.6417349258746233`*^9}, {3.6417477233123283`*^9, 
   3.6417477284017477`*^9}, 3.641748724837962*^9, 3.64175854338424*^9, 
   3.6417653429167624`*^9, {3.6417658979138317`*^9, 3.641765905518532*^9}, {
   3.641765962037958*^9, 3.641765988950038*^9}, {3.641837587802647*^9, 
   3.641837607475284*^9}, {3.641837707215397*^9, 3.6418377157959347`*^9}, {
   3.641837781675887*^9, 3.641837784484664*^9}, {3.641837814726337*^9, 
   3.6418378194877443`*^9}, 3.641838117953759*^9, {3.6418386576451683`*^9, 
   3.64183865800729*^9}, {3.642240759294689*^9, 3.642240794615106*^9}, 
   3.6422426607988987`*^9, {3.64224273067559*^9, 3.6422427320414124`*^9}, {
   3.642248612592617*^9, 3.64224861794984*^9}, {3.642250843559865*^9, 
   3.642250854123547*^9}, 3.6431938548309*^9, {3.64319432865134*^9, 
   3.643194331557693*^9}, {3.643194451752842*^9, 3.643194477379078*^9}, 
   3.643195381528534*^9, {3.644435459604545*^9, 3.64443547255678*^9}, {
   3.6444355778997*^9, 3.644435584047957*^9}, {3.6444356458485527`*^9, 
   3.64443564614151*^9}, {3.6444356809591093`*^9, 3.644435695487666*^9}, {
   3.6444357541015053`*^9, 3.644435775506501*^9}, {3.644436245891818*^9, 
   3.644436246631002*^9}, 3.644437205446958*^9, {3.644659844547031*^9, 
   3.6446598459929523`*^9}, 3.647768537598474*^9, 3.647790396987311*^9, {
   3.648148675732334*^9, 3.648148682533846*^9}, {3.650029039236556*^9, 
   3.6500290465122538`*^9}, {3.650218309781557*^9, 3.6502184312358103`*^9}, {
   3.650218465066164*^9, 3.650218635165909*^9}, {3.6503002362132607`*^9, 
   3.6503002409129457`*^9}, {3.6503002750598917`*^9, 
   3.6503002769207706`*^9}, {3.6503023476869087`*^9, 3.650302383962723*^9}, {
   3.650302483992885*^9, 3.650302515093164*^9}, {3.650302573781035*^9, 
   3.6503026066777554`*^9}, 3.650303208323348*^9, {3.650308863605835*^9, 
   3.650308864199682*^9}, {3.6503092754792*^9, 3.650309302281291*^9}, {
   3.650309368031536*^9, 3.6503093686997557`*^9}, {3.6503096729116793`*^9, 
   3.650309673181209*^9}, 3.6503102224508457`*^9, 3.6503103273870564`*^9, {
   3.650312634133803*^9, 3.650312644350665*^9}, {3.650315722064295*^9, 
   3.6503157233981657`*^9}, {3.65031624315212*^9, 3.650316285747093*^9}, 
   3.650316495059383*^9, 3.650316776277199*^9, {3.650969191042747*^9, 
   3.650969192576684*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generating the graph (steet network)", "Subsection",
 CellChangeTimes->{{3.648148887787671*^9, 3.6481489161866693`*^9}, {
  3.650218732635336*^9, 3.6502187402182417`*^9}, {3.650303289462879*^9, 
  3.6503032905663967`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "The", " ", "function", " ", "MorphologicalGraph", " ", "is", " ", "used",
      " ", "to", " ", "obtain", " ", "the", " ", "graph", " ", 
     RowBox[{"(", "network", ")"}], " ", "based", " ", "on", " ", "the", " ", 
     "map", " ", "of", " ", "the", " ", "streets", " ", "of", " ", "Cali"}], 
    ";", " ", 
    RowBox[{
    "a", " ", "vertex", " ", "represents", " ", "a", " ", "corner", " ", 
     "and", " ", "an", " ", "edge", " ", "represents", " ", "a", " ", 
     RowBox[{"street", ".", " ", "If"}], " ", "you", " ", "print", " ", "g", 
     " ", "you", " ", "can", " ", "observe", " ", "the", " ", "graph"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"MorphologicalGraph", "[", 
      RowBox[{"mapa1", ",", 
       RowBox[{"EdgeStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"Import", "[", "\"\<graph.graphml\>\"", "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"We", " ", "import", " ", "g"}], ",", " ", 
     RowBox[{
     "becuase", " ", "MorphologicalGraph", " ", "sometimes", " ", "takes", 
      " ", "too", " ", "much", " ", "excecution", " ", "time"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertex", "=", 
     RowBox[{"VertexList", "[", "g", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "The", " ", "code", " ", "below", " ", "finds", " ", "the", " ", "geo"}],
      "-", 
     RowBox[{"coordinates", " ", 
      RowBox[{"(", 
       RowBox[{"latitude", ",", "longitude"}], ")"}], " ", "of", " ", "each", 
      " ", 
      RowBox[{"corner", ".", "The"}], " ", "list", " ", "pointscoverted", " ",
       "stores", " ", "this", " ", "information"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lista", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"PropertyValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"g", ",", "n"}], "}"}], ",", "VertexCoordinates"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "vertex"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dim", "=", 
     RowBox[{"ImageDimensions", "[", "mapa1", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid2", "=", 
     RowBox[{
      RowBox[{"AbsoluteOptions", "[", 
       RowBox[{
        RowBox[{"ListPlot", "[", "lista", "]"}], ",", "PlotRange"}], "]"}], 
      "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"f1", "=", 
     RowBox[{"Fit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"dim", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"line1", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"f1", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}], "x"}], "+", 
      RowBox[{"f1", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"f2", "=", 
     RowBox[{"Fit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ")"}], ",", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"line2", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"f2", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}], "*", "x"}], "+", 
      RowBox[{"f2", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pointsconverted", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"GeoPosition", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"line1", "[", 
           RowBox[{"lista", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"line2", "[", 
           RowBox[{"lista", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "lista", "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "This", " ", "function", " ", "returns", " ", "True", " ", "if", " ", "a",
      " ", "corner", " ", 
     RowBox[{"(", 
      RowBox[{"x", ",", ",", "y"}], ")"}], " ", "is", " ", "inside", " ", 
     "the", " ", 
     RowBox[{"polygon", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"inPolyQ", "=", 
     RowBox[{"Compile", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"poly", ",", "_Real", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "_Real"}], "}"}]}], "}"}], ",", 
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "Xi", ",", "Yi", ",", "Xip1", ",", "Yip1", ",", "u", ",", "v", ",", 
           "w"}], "}"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Xi", ",", "Yi"}], "}"}], "=", 
           RowBox[{"Transpose", "@", "poly"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Xip1", "=", 
           RowBox[{"RotateLeft", "@", "Xi"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Yip1", "=", 
           RowBox[{"RotateLeft", "@", "Yi"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"u", "=", 
           RowBox[{"UnitStep", "[", 
            RowBox[{"y", "-", "Yi"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"v", "=", 
           RowBox[{"RotateLeft", "@", "u"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"w", "=", 
           RowBox[{"UnitStep", "[", 
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Xip1", "-", "Xi"}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{"y", "-", "Yi"}], ")"}]}], "-", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"x", "-", "Xi"}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{"Yip1", "-", "Yi"}], ")"}]}]}], ")"}]}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Total", "[", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"u", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", "v"}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", "w"}], ")"}]}], "-", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "-", "u"}], ")"}], " ", "v", " ", "w"}]}], ")"}],
             "]"}], "\[NotEqual]", "0"}]}]}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "consider", " ", "only", " ", "corners", " ", "that", " ", "are", " ", 
     "inside", " ", "the", " ", "polygon", " ", "of", " ", "Cali"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"coordinates", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"line1", "[", 
          RowBox[{"lista", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"line2", "[", 
          RowBox[{"lista", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "lista", "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"VertexDelete", "[", 
      RowBox[{"g", ",", 
       RowBox[{"Pick", "[", 
        RowBox[{
         RowBox[{"VertexList", "[", "g", "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Not", "[", 
            RowBox[{"inPolyQ", "[", 
             RowBox[{
              RowBox[{"y1", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
              ",", 
              RowBox[{"coordinates", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"coordinates", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"VertexList", "[", "g", "]"}], "]"}]}], "}"}]}], 
          "]"}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertex", "=", 
     RowBox[{"VertexList", "[", "g", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lista", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"PropertyValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"g", ",", "n"}], "}"}], ",", "VertexCoordinates"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "vertex"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pointsconverted", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"GeoPosition", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"line1", "[", 
           RowBox[{"lista", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"line2", "[", 
           RowBox[{"lista", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "lista", "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "This", " ", "code", " ", "was", " ", "developed", " ", "to", " ", 
     "verify", " ", "that", " ", "the", " ", "position", " ", "of", " ", 
     "the", " ", "vertices", " ", "are", " ", "the", " ", "corners", " ", 
     "of", " ", "the", " ", "street", " ", 
     RowBox[{"effectively", ".", "If"}], " ", "you", " ", "want", " ", "you", 
     " ", "can", " ", "print", " ", 
     RowBox[{"mapa", ".", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"execution", " ", "time"}], "=", 
        RowBox[{"25", " ", "segs"}]}], ")"}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y", "=", 
     RowBox[{
      RowBox[{"Lookup", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"\"\<roadHierarchy.zip\>\"", ",", "\"\<Data\>\""}], "]"}], 
        ",", "\"\<Geometry\>\""}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lista", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"y", "[", 
        RowBox[{"[", 
         RowBox[{"k", ",", "1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "principalstreets"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"geoPlotStyle", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
       RowBox[{"GeoBackground", "\[Rule]", "None"}], ",", 
       RowBox[{"GeoScaleBar", "\[Rule]", "\"\<Metric\>\""}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", "None"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertex", "=", 
     RowBox[{"ToExpression", "[", "vertex", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"numberofnodes", "=", 
     RowBox[{"Length", "[", "vertex", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertexposition", "=", 
     RowBox[{"Association", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"vertex", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", " ", 
         RowBox[{"pointsconverted", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "numberofnodes"}], "}"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertexnumber", "=", 
     RowBox[{"Association", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"vertex", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", "i"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "numberofnodes"}], "}"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mapa", "=", 
     RowBox[{"GeoGraphics", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EdgeForm", "[", "Blue", "]"}], ",", 
           RowBox[{"FaceForm", "[", "None", "]"}], ",", "y1"}], "}"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Black", ",", 
             RowBox[{"GeoPath", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
          "Lista"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Red", ",", 
             RowBox[{"Point", "[", 
              RowBox[{"Lookup", "[", 
               RowBox[{"vertexposition", ",", "#"}], "]"}], "]"}]}], "}"}], 
           "&"}], "/@", "vertex"}]}], "}"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
       RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
       RowBox[{"GeoBackground", "\[Rule]", "None"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
      "Events", " ", "will", " ", "occur", " ", "on", " ", "the", " ", 
       "nodes", " ", "of", " ", "the", " ", "graph", " ", "g"}], ";", " ", 
      RowBox[{"in", " ", "other", " ", "words"}]}], ",", " ", 
     RowBox[{
      RowBox[{
      "at", " ", "the", " ", "instersection", " ", "of", " ", "streets"}], 
      ";", " ", 
      RowBox[{
      "the", " ", "coordinates", " ", "of", " ", "these", " ", "nodes", " ", 
       "can", " ", "be", " ", "drawn", " ", "using", " ", 
       RowBox[{"GraphEmbedding", "[", "g", "]"}]}], ";", " ", 
      RowBox[{
       RowBox[{"VertexCount", "[", "g", "]"}], "=", "1013"}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"g", ",", " ", 
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"GraphEmbedding", "[", "g", "]"}], ",", " ", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"Directive", "[", 
           RowBox[{
            RowBox[{"Darker", "@", "Green"}], ",", 
            RowBox[{"PointSize", "[", "Medium", "]"}]}], "]"}]}]}], "]"}]}], 
      "]"}], ",", "\[IndentingNewLine]", "mapa"}], "}"}]}]}]], "Input",
 CellChangeTimes->{
  3.65030867874937*^9, {3.650308808362362*^9, 3.6503088146504717`*^9}, 
   3.650309235879426*^9, 3.650309828467155*^9, 3.650310336250655*^9, {
   3.650311773258931*^9, 3.6503117852761297`*^9}, {3.6503118207886763`*^9, 
   3.650311885502696*^9}, {3.650311982664709*^9, 3.650312058338769*^9}, {
   3.6503124874904346`*^9, 3.650312491607799*^9}, {3.650314287982254*^9, 
   3.650314293900565*^9}, {3.650315579378807*^9, 3.65031578763883*^9}, 
   3.650316315544321*^9, {3.650321438981989*^9, 3.650321442013258*^9}, {
   3.650381199223936*^9, 3.650381212915956*^9}, 3.650381688111629*^9, {
   3.6503818536557007`*^9, 3.650381856098401*^9}, {3.65045694658289*^9, 
   3.650456960070581*^9}, {3.6504614376406803`*^9, 3.650461447681919*^9}, {
   3.6504617757556553`*^9, 3.650461778267112*^9}, {3.650629633529275*^9, 
   3.650629641137438*^9}, {3.650916532878151*^9, 3.650916534884487*^9}, {
   3.650916650073187*^9, 3.650916686448461*^9}, {3.650916797275681*^9, 
   3.650916830889072*^9}, 3.650917692359273*^9, {3.650919545925106*^9, 
   3.6509195512110767`*^9}, {3.650919883801764*^9, 3.650919911735134*^9}, {
   3.65092163352566*^9, 3.650921638366971*^9}, {3.65096444228286*^9, 
   3.650964481976796*^9}, 3.6509655777186317`*^9, {3.650967247087591*^9, 
   3.650967247344874*^9}, {3.650967399020214*^9, 3.6509674227319393`*^9}, {
   3.6509675509969683`*^9, 3.650967560415207*^9}, {3.650968056217986*^9, 
   3.6509680686199617`*^9}, {3.650968139204359*^9, 3.65096814493858*^9}, {
   3.650968246102234*^9, 3.650968251882688*^9}, {3.650969198945095*^9, 
   3.6509692035547123`*^9}, {3.6509697266855087`*^9, 3.650969737889654*^9}, {
   3.65096977167493*^9, 3.6509697768047047`*^9}, {3.650970548093974*^9, 
   3.650970629140267*^9}, {3.650970659916411*^9, 3.650970661179566*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Initializing the model ", "Subsection",
 CellChangeTimes->{{3.648150286362629*^9, 3.648150325895492*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Definitions", " ", "of", " ", "the", " ", "model", " ", "parameters", 
     " ", "to", " ", "generate", " ", "events", " ", "across", " ", "the", 
     " ", "steet", " ", "network"}], ";", " ", 
    RowBox[{
    "see", " ", "reference", " ", "paper", " ", "for", " ", "details"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"numerOfDaysOfData", "=", "10"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
    "change", " ", "this", " ", "parameter", " ", "if", " ", "you", " ", 
     "want", " ", "data", " ", "for", " ", "longer", " ", "time", " ", 
     "periods"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"l", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dt", "=", "0.02"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w", "=", 
     RowBox[{"1", "/", "15.0"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A0", "=", 
     RowBox[{"1", "/", "30.0"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"eta", "=", "0.03"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"theta", "=", "0.56"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gama", "=", "0.019"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bmedia", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"theta", "*", "gama"}], ")"}], "/", "w"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Amedia", "=", 
     RowBox[{"A0", "+", "Bmedia"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nmedia", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"gama", "*", "dt"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"Amedia", "*", "dt"}], ")"}]}], "]"}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"neigh", "=", 
     RowBox[{"<<", "\"\<neighbors-principalstreets-cali.txt\>\""}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vertexneighbors", "=", " ", 
     RowBox[{"Association", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
         "vertex", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
         "\[Rule]", " ", 
         RowBox[{
         "neigh", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "numberofnodes"}], "}"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list1", "=", 
     RowBox[{"RandomChoice", "[", 
      RowBox[{
       RowBox[{"Range", "[", "numberofnodes", "]"}], ",", 
       RowBox[{"IntegerPart", "[", 
        RowBox[{"nmedia", " ", "numberofnodes"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ns", "=", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", "numberofnodes"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ns", "\[LeftDoubleBracket]", 
        RowBox[{
        "list1", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], 
        "\[RightDoubleBracket]"}], "=", 
       RowBox[{
        RowBox[{"ns", "\[LeftDoubleBracket]", 
         RowBox[{
         "list1", "\[LeftDoubleBracket]", "s", "\[RightDoubleBracket]"}], 
         "\[RightDoubleBracket]"}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"Length", "[", "list1", "]"}]}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bs", "=", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"Bmedia", ",", "numberofnodes"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"As", "=", 
     RowBox[{"A0", "+", "Bs"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Es", "=", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", "numberofnodes"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.642276979529648*^9, 3.642276983941224*^9}, {
   3.642277345852221*^9, 3.6422773552259703`*^9}, 3.644158844907784*^9, {
   3.644438400823237*^9, 3.6444384086500597`*^9}, {3.645269812256846*^9, 
   3.645269830208522*^9}, {3.648150039362596*^9, 3.6481500487540493`*^9}, {
   3.6481501268061037`*^9, 3.6481501381081133`*^9}, {3.648150231278618*^9, 
   3.648150232469215*^9}, {3.650026532657331*^9, 3.650026545709919*^9}, {
   3.650028166256665*^9, 3.650028174455821*^9}, {3.6500290929277763`*^9, 
   3.650029114355857*^9}, {3.650041384385181*^9, 3.6500413854481907`*^9}, {
   3.650218822336258*^9, 3.650218913672526*^9}, {3.650219060801318*^9, 
   3.650219125961721*^9}, {3.650221707491601*^9, 3.6502217078511066`*^9}, {
   3.650311202317127*^9, 3.6503112263064938`*^9}, {3.650311307196836*^9, 
   3.650311310776808*^9}, {3.650311462861051*^9, 3.650311462978715*^9}, 
   3.65031149444283*^9, {3.650312941435217*^9, 3.650312956258216*^9}, {
   3.650314142112446*^9, 3.650314154134824*^9}, {3.6503142550866957`*^9, 
   3.650314257525012*^9}, 3.65031524438099*^9, {3.6503153538950357`*^9, 
   3.65031540721138*^9}, {3.650315494553981*^9, 3.650315519727318*^9}, {
   3.650315935110099*^9, 3.6503159499676247`*^9}, {3.650316516653699*^9, 
   3.6503165169414682`*^9}, {3.650316631635347*^9, 3.65031663641142*^9}, {
   3.650316730205315*^9, 3.6503167329174767`*^9}, {3.650317038580044*^9, 
   3.650317039024441*^9}, {3.650320416512137*^9, 3.650320417301031*^9}, {
   3.650321429805686*^9, 3.650321434847925*^9}, 3.650322060696602*^9, {
   3.650323763961378*^9, 3.650323765407586*^9}, {3.6503238795007772`*^9, 
   3.650323897324512*^9}, {3.650324331273019*^9, 3.650324332042053*^9}, {
   3.65032660481246*^9, 3.6503266064871902`*^9}, {3.6503604731726303`*^9, 
   3.650360474282919*^9}, 3.6503734481012573`*^9, {3.650373489586*^9, 
   3.6503734907677507`*^9}, {3.650373538014827*^9, 3.650373560919808*^9}, {
   3.650373757574832*^9, 3.6503737600676603`*^9}, {3.650374926742641*^9, 
   3.6503749603823967`*^9}, {3.650380085910276*^9, 3.6503801107045593`*^9}, {
   3.6503802280333776`*^9, 3.6503802343109837`*^9}, {3.650381266069063*^9, 
   3.650381267058783*^9}, {3.650394622050622*^9, 3.650394622755018*^9}, {
   3.650460427636928*^9, 3.650460429210918*^9}, {3.650627135935527*^9, 
   3.650627136827464*^9}, {3.65091770692588*^9, 3.6509177081578407`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "This", " ", "is", " ", "the", " ", "loop", " ", "of", " ", "the", " ", 
     RowBox[{"model", ".", "The"}], " ", "variable", " ", "Bs", " ", 
     "represents", " ", "the", " ", "attractiveness", " ", "of", " ", "all", 
     " ", "corners", " ", "in", " ", "the", " ", "actual", " ", 
     RowBox[{"day", ".", " ", "And"}]}], ",", 
    RowBox[{
    "B", " ", "stores", " ", "the", " ", "variable", " ", "Bs", " ", "every", 
     " ", "day", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"execution", " ", "time"}], "=", 
       RowBox[{"10", " ", "segs", " ", "for", " ", "10", " ", "days"}]}], 
      ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"B", "=", 
     RowBox[{"{", "Bs", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"number", " ", "=", " ", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bsdt", "=", "Bs"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nsdt", "=", "ns"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nbulgars", "=", "0"}], ";"}], 
   RowBox[{"(*", 
    RowBox[{"number", " ", "of", " ", "bulgars", " ", "produced"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ncp", "=", 
     RowBox[{"gama", "*", "dt", "*", "numberofnodes"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "number", " ", "of", " ", "criminal", " ", "produced", " ", "each", " ", 
     "dt"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"psn", "=", "1"}], ";"}], 
   RowBox[{"(*", 
    RowBox[{"position", " ", "new", " ", "bulgar"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"listpositions", "=", "vertex"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Timing", "[", 
    RowBox[{"Monitor", "[", 
     RowBox[{
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"day", "=", "0.0"}], ",", 
        RowBox[{"day", "<", " ", 
         RowBox[{"numerOfDaysOfData", "+", "dt"}]}], ",", 
        RowBox[{"day", "=", 
         RowBox[{"day", "+", "dt"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Es", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"0", ",", "numberofnodes"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ns", "[", 
                RowBox[{"[", "position", "]"}], "]"}], "\[NotEqual]", " ", 
               "0"}], ",", 
              RowBox[{
               RowBox[{"ps", "=", 
                RowBox[{"1", "-", 
                 RowBox[{"Exp", "[", 
                  RowBox[{
                   RowBox[{"-", 
                    RowBox[{"As", "[", 
                    RowBox[{"[", "position", "]"}], "]"}]}], "*", "dt"}], 
                  "]"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"burgle", "=", 
                RowBox[{"RandomChoice", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "-", "ps"}], ",", "ps"}], "}"}], "\[Rule]", 
                   " ", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], ",", 
                  RowBox[{"ns", "[", 
                   RowBox[{"[", "position", "]"}], "]"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Do", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"burgle", "[", 
                    RowBox[{"[", "s", "]"}], "]"}], "\[Equal]", "1"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Es", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"Es", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], "+", "1"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], " ", "-", 
                    "1"}]}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"sp", "=", 
                    RowBox[{"neigh", "[", 
                    RowBox[{"[", "position", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"sp", "=", 
                    RowBox[{"Lookup", "[", 
                    RowBox[{"vertexnumber", ",", "sp"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"qsn", "=", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"As", "[", 
                    RowBox[{"[", "s", "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"s", ",", "sp"}], "}"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"qsn", "=", 
                    RowBox[{"qsn", "/", 
                    RowBox[{"Total", "[", "qsn", "]"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"sn", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"qsn", "\[Rule]", " ", "sp"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "sn", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "sn", "]"}], "]"}], "+", "1"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], "=", 
                    RowBox[{
                    RowBox[{"nsdt", "[", 
                    RowBox[{"[", "position", "]"}], "]"}], " ", "-", "1"}]}], 
                    ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
                 "\[IndentingNewLine]", ",", 
                 RowBox[{"{", 
                  RowBox[{"s", ",", 
                   RowBox[{"Length", "[", "burgle", "]"}]}], "}"}]}], "]"}], 
               ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"position", ",", "numberofnodes"}], "}"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"sp", "=", 
             RowBox[{"neigh", "[", 
              RowBox[{"[", "position", "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"sp", "=", 
             RowBox[{"Lookup", "[", 
              RowBox[{"vertexnumber", ",", "sp"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"z", "=", 
             RowBox[{"Length", "[", "sp", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Bsdt", "[", 
              RowBox[{"[", "position", "]"}], "]"}], "=", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1", "-", "eta"}], ")"}], "*", 
                  RowBox[{"Bs", "[", 
                   RowBox[{"[", "position", "]"}], "]"}]}], "+", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"eta", "/", "z"}], ")"}], "*", 
                  RowBox[{"Sum", "[", 
                   RowBox[{
                    RowBox[{"Bs", "[", 
                    RowBox[{"[", "s", "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"s", ",", "sp"}], "}"}]}], "]"}]}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"w", "*", "dt"}]}], ")"}]}], "+", 
              RowBox[{"theta", "*", 
               RowBox[{"Es", "[", 
                RowBox[{"[", "position", "]"}], "]"}]}]}]}], ";"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"position", ",", "numberofnodes"}], "}"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nbulgars", "=", 
          RowBox[{"nbulgars", "+", " ", "ncp"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"psn", "=", 
             RowBox[{"RandomChoice", "[", "listpositions", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"psn1", "=", 
             RowBox[{"Lookup", "[", 
              RowBox[{"vertexnumber", ",", "psn"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"nsdt", "[", 
              RowBox[{"[", "psn1", "]"}], "]"}], "=", 
             RowBox[{
              RowBox[{"nsdt", "[", 
               RowBox[{"[", "psn1", "]"}], "]"}], "+", "1"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "listpositions", "]"}], ">", "1"}], ",", 
              RowBox[{"listpositions", "=", 
               RowBox[{"DeleteCases", "[", 
                RowBox[{"listpositions", ",", "psn"}], "]"}]}], ",", 
              RowBox[{"listpositions", "=", "vertex"}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"s", ",", "1", ",", 
             RowBox[{"IntegerPart", "[", "nbulgars", "]"}]}], "}"}]}], "]"}], 
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nbulgars", "=", 
          RowBox[{"nbulgars", "-", 
           RowBox[{"IntegerPart", "[", "nbulgars", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ns", "=", "nsdt"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Bs", "=", "Bsdt"}], ";", "\[IndentingNewLine]", 
         RowBox[{"As", "=", 
          RowBox[{"A0", "+", "Bs"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"number", "=", 
          RowBox[{"number", " ", "+", "1"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "If", " ", "you", " ", "want", " ", "to", " ", "store", " ", "Bs", 
           " ", "every", " ", "10", " ", "days", " ", "you", " ", "have", " ",
            "to", " ", "change", " ", "50", " ", "by", " ", "500"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"number", ",", "50"}], "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{"B", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"B", ",", 
              RowBox[{"{", "Bs", "}"}]}], "]"}]}]}], "]"}], ";"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ",", "day"}], 
     "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6419123057695436`*^9, 3.641912307817669*^9}, 
   3.6419123381829233`*^9, {3.6419126084750233`*^9, 3.641912685931416*^9}, 
   3.6419127334583607`*^9, {3.641912959372493*^9, 3.641912981568121*^9}, 
   3.6419130385932198`*^9, {3.641913161419951*^9, 3.6419131807740173`*^9}, {
   3.6419132314819317`*^9, 3.6419132555933037`*^9}, {3.641913305749014*^9, 
   3.641913313579458*^9}, {3.641913347961013*^9, 3.641913354628582*^9}, {
   3.641913386408145*^9, 3.641913388183023*^9}, {3.641913717033176*^9, 
   3.641913720532542*^9}, {3.641913756953765*^9, 3.641913790856806*^9}, {
   3.6419138241779633`*^9, 3.6419138632048607`*^9}, {3.6419139446165543`*^9, 
   3.641913952261281*^9}, {3.6419160911441803`*^9, 3.641916092159083*^9}, {
   3.644159217226569*^9, 3.644159217911935*^9}, {3.6441595583000393`*^9, 
   3.644159558864835*^9}, {3.6452942328496847`*^9, 3.645294246191202*^9}, {
   3.647768866691886*^9, 3.647768882482177*^9}, {3.647769013221918*^9, 
   3.6477690308940153`*^9}, {3.648150525536187*^9, 3.6481505418236427`*^9}, {
   3.648150845168832*^9, 3.648150886777472*^9}, 3.650028375375135*^9, 
   3.65002866217223*^9, {3.650029200736071*^9, 3.6500292049391212`*^9}, {
   3.650041972684348*^9, 3.650042002094533*^9}, {3.650042168116313*^9, 
   3.6500422210958776`*^9}, {3.650043511705175*^9, 3.650043535270033*^9}, {
   3.6502189505965157`*^9, 3.65021897848663*^9}, {3.65021909536526*^9, 
   3.650219101675263*^9}, {3.650219191136042*^9, 3.6502192141306458`*^9}, {
   3.650315267671146*^9, 3.650315272550996*^9}, {3.650316665710663*^9, 
   3.65031666938414*^9}, {3.650316743216094*^9, 3.650316750015057*^9}, {
   3.6503168460799637`*^9, 3.650316847372085*^9}, {3.650321419616982*^9, 
   3.65032142385568*^9}, {3.650323968879566*^9, 3.650323970284754*^9}, {
   3.6503243429916897`*^9, 3.6503243439500504`*^9}, {3.650360489583516*^9, 
   3.650360504687949*^9}, {3.6503812950388107`*^9, 3.650381376531796*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15.913368`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.650970386305663*^9, 3.651434026603516*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Length", "[", "B", "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "The", " ", "lenght", " ", "of", " ", "B", " ", "is", " ", "the", " ", 
    "number", " ", "of", " ", "days", " ", "plus", " ", "1", " ", 
    RowBox[{"(", 
     RowBox[{
     "the", " ", "first", " ", "item", " ", "of", " ", "B", " ", "is", " ", 
      "the", " ", "initial", " ", "condition"}], ")"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.6477691495813026`*^9, 3.6477691513342333`*^9}, {
  3.647769188082176*^9, 3.647769191327981*^9}, {3.64776931772862*^9, 
  3.6477693195404377`*^9}, {3.647769352146546*^9, 3.6477693522841263`*^9}, {
  3.648150908605043*^9, 3.6481509756146727`*^9}}],

Cell[BoxData["11"], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGDQAOJ5bjs8Juq+dtSQ+uoDoj8zs8WC6Hf+Eokgmmm5+QZv
vdeOWSVTmh8Yvnb86s1yHUTX/F534RmQ3vpnjf1zIP121do7IPp906J5tkav
HYOspb2zgLTF8dls2UCaZ37jExCtsfa/Rw6Q7ub0/w6iz/R6u+UC6VmGf3/n
AemWoDL3fCA9PTl1OYjmOBlZVQCk+yU/XQXRXj1BMoVAelrzjnYQbbSnf3MJ
kG4SuLKuCUgr9fd2dYLoX8x3QfSU32eudQHpXVZnxXpB5iY9VgLRiw7P2gSi
mfg0QycBaUmmiRWTgbSaazHrJiD9ZqvgXRbj144HJvw0ZwXSQVIi90F05qO3
yWuAtPJtjuN9Jq8dATO4m8c=
  "]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Graphics about the model", "Subsection",
 CellChangeTimes->{{3.648151334551848*^9, 3.6481513405977793`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Here", ",", " ", 
    RowBox[{
    "you", " ", "can", " ", "plot", " ", "the", " ", "attractiveness", " ", 
     "of", " ", "each", " ", 
     RowBox[{"corner", ".", " ", "You"}], " ", "can", " ", "choose", " ", 
     "the", " ", "day", " ", "that", " ", "you", " ", "want", " ", "to", " ", 
     "plot", " ", "by", " ", "specifying", " ", "the", " ", "variable", " ", 
     RowBox[{"\"\<day\>\"", ".", " ", "The"}], " ", "color", " ", "of", " ", 
     "the", " ", "vertex", " ", "depends", " ", "on", " ", "its", " ", 
     "value", " ", "of", " ", "attractiveness", " ", 
     RowBox[{"(", 
      RowBox[{"execution", " ", "approximately", " ", "20", " ", "segs"}], 
      ")"}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"day", "=", "10"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3.331", ",", "3.506"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "76.593"}], ",", 
         RowBox[{"-", "76.461"}]}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"max", "=", 
     RowBox[{"2", "*", "Bmedia"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"colorData", "=", 
     RowBox[{"ColorData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<Rainbow\>\"", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "max"}], "}"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y", "=", 
     RowBox[{"Lookup", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"\"\<BoundCali.zip\>\"", ",", "\"\<Data\>\""}], "]"}], ",", 
       "\"\<Geometry\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y1", "=", 
     RowBox[{"y", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"GeoGraphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", 
            RowBox[{"FaceForm", "[", "None", "]"}], ",", "y1"}], "}"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", 
              RowBox[{"GeoPath", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
           "Lista"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"colorData", "[", 
               RowBox[{"B", "\[LeftDoubleBracket]", 
                RowBox[{"day", ",", 
                 RowBox[{"Lookup", "[", 
                  RowBox[{"vertexnumber", ",", "#"}], "]"}]}], 
                "\[RightDoubleBracket]"}], "]"}], ",", 
              RowBox[{"Point", "[", 
               RowBox[{"Lookup", "[", 
                RowBox[{"vertexposition", ",", "#"}], "]"}], "]"}]}], "}"}], 
            "&"}], "/@", "vertex"}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
        RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
        RowBox[{"GeoBackground", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"BarLegend", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "colorData", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "max"}], "}"}]}], "}"}], "]"}]}], "}"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.641915464969131*^9, 3.641915605908082*^9}, {
   3.64191566698141*^9, 3.641915674888219*^9}, {3.641916033926691*^9, 
   3.641916034018417*^9}, {3.64224098745179*^9, 3.642240987537476*^9}, {
   3.6447714895288353`*^9, 3.644771491200865*^9}, 3.644772086194933*^9, {
   3.6447721177316113`*^9, 3.644772118535234*^9}, {3.644777256676188*^9, 
   3.6447772571884212`*^9}, {3.645298224744195*^9, 3.645298225390868*^9}, 
   3.647769404896707*^9, {3.648151402718597*^9, 3.6481514119832363`*^9}, {
   3.648151508334015*^9, 3.648151525757052*^9}, {3.648151816932199*^9, 
   3.6481518172395287`*^9}, {3.648153063629939*^9, 3.648153063695202*^9}, {
   3.6500239463224087`*^9, 3.650023946726028*^9}, {3.650028295178481*^9, 
   3.650028324882568*^9}, 3.650028424882524*^9, {3.6500286518484707`*^9, 
   3.650028653110968*^9}, {3.650029245537442*^9, 3.6500292508215322`*^9}, {
   3.650219943574687*^9, 3.6502200067056704`*^9}, {3.650220084480158*^9, 
   3.650220084624645*^9}, {3.6502202879143877`*^9, 3.650220289375533*^9}, {
   3.650220471909697*^9, 3.6502204796254807`*^9}, {3.6502206727800417`*^9, 
   3.6502206728570642`*^9}, {3.650220907197399*^9, 3.650220935849164*^9}, {
   3.650221025332975*^9, 3.650221064317348*^9}, {3.650221642849245*^9, 
   3.65022164422114*^9}, {3.650221907664213*^9, 3.6502219078548098`*^9}, {
   3.650221945441485*^9, 3.6502219468139553`*^9}, 3.650310865057767*^9, 
   3.650315094859601*^9, {3.650315171762643*^9, 3.650315171935802*^9}, {
   3.650315862682723*^9, 3.650315863166602*^9}, {3.650316294591567*^9, 
   3.6503162957381144`*^9}, {3.650316441258564*^9, 3.650316441430257*^9}, {
   3.650316863452487*^9, 3.650316863735958*^9}, {3.650317046745016*^9, 
   3.650317047312067*^9}, {3.650320431328557*^9, 3.650320431660967*^9}, 
   3.650321199352138*^9, {3.6503220777849617`*^9, 3.650322077916127*^9}, 
   3.650323507228313*^9, {3.650323617313909*^9, 3.6503236191574383`*^9}, {
   3.650323733019211*^9, 3.6503237331668587`*^9}, {3.6503242508802032`*^9, 
   3.650324254324669*^9}, {3.650324791413542*^9, 3.650324792119217*^9}, {
   3.6503248619702597`*^9, 3.650324862097514*^9}, {3.6503747879424067`*^9, 
   3.650374788282547*^9}, {3.650374843506774*^9, 3.6503748444978237`*^9}, 
   3.6503818810333843`*^9, {3.650395105081251*^9, 3.650395106248733*^9}, {
   3.6504603962521067`*^9, 3.6504603963395443`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"day", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", "=", 
   RowBox[{"2", "*", "Bmedia"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bsat", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Clip", "[", 
      RowBox[{
       RowBox[{"B", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "max"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "B", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Append", "[", 
      RowBox[{
       RowBox[{"Reverse", "@", 
        RowBox[{
         RowBox[{"Lookup", "[", 
          RowBox[{"vertexposition", ",", 
           RowBox[{"vertex", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "\[LeftDoubleBracket]", 
         "1", "\[RightDoubleBracket]"}]}], ",", 
       RowBox[{"Bsat", "[", 
        RowBox[{"[", 
         RowBox[{"day", ",", "i"}], "]"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "vertex", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"colfunc", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"ColorData", "[", "\"\<Rainbow\>\"", "]"}], "[", 
     RowBox[{"#", "/", "max"}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"leg", "=", 
   RowBox[{"BarLegend", "[", 
    RowBox[{"{", 
     RowBox[{"colfunc", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "max"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"modelDensity", "=", 
   RowBox[{"ListContourPlot", "[", 
    RowBox[{"list", ",", 
     RowBox[{"Frame", "\[Rule]", "False"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"Reverse", "@", "grid"}], ",", "All"}], "]"}]}], ",", 
     RowBox[{"Contours", "\[Rule]", "15"}], ",", 
     RowBox[{"ContourLines", "\[Rule]", "False"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", "colfunc"}], ",", 
     RowBox[{"ColorFunctionScaling", "->", "False"}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
     RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"geoPlotStyle", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
     RowBox[{"GeoScaleBar", "\[Rule]", "\"\<Metric\>\""}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameTicks", "\[Rule]", "None"}], ",", 
     RowBox[{"Exclusions", "\[Rule]", "None"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GeoGraphics", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"GeoStyling", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<GeoImage\>\"", ",", "modelDensity"}], "}"}], "]"}], ",",
        "y1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"EdgeForm", "[", "Gray", "]"}], ",", 
       RowBox[{"FaceForm", "[", "None", "]"}], ",", "y1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"GeoRange", "\[Rule]", "grid"}], ",", 
   RowBox[{"GeoBackground", "\[Rule]", "None"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.650382866659306*^9, 3.650382881875719*^9}, {
   3.6503839787273006`*^9, 3.650383980393219*^9}, {3.6503840937242126`*^9, 
   3.650384201536631*^9}, {3.650393179118297*^9, 3.650393190834372*^9}, {
   3.6503932450625467`*^9, 3.650393246841962*^9}, {3.650393282064219*^9, 
   3.6503932932676764`*^9}, 3.650393354531926*^9, {3.650393455530921*^9, 
   3.650393617414131*^9}, {3.65039365911234*^9, 3.6503936652540903`*^9}, {
   3.650393750572618*^9, 3.650393795092342*^9}, {3.650394319212225*^9, 
   3.650394320060006*^9}, {3.650394351303603*^9, 3.650394378198805*^9}, {
   3.650394411184107*^9, 3.6503944315359077`*^9}, 3.650394474418219*^9, {
   3.6503945309404984`*^9, 3.6503945319940157`*^9}, {3.650394576934318*^9, 
   3.6503945988261642`*^9}, {3.6503961406354923`*^9, 
   3.6503961465871964`*^9}, {3.650396421332416*^9, 3.650396439872802*^9}, {
   3.650396476216054*^9, 3.6503964877795143`*^9}, 3.650396532590973*^9, {
   3.65039659347491*^9, 3.650396682413542*^9}, {3.650396751794087*^9, 
   3.650396752315414*^9}, {3.650396801596394*^9, 3.650396804342423*^9}, {
   3.650396934050832*^9, 3.650396934341634*^9}, {3.650397143496809*^9, 
   3.650397144372068*^9}, {3.650397179721328*^9, 3.650397186039537*^9}, {
   3.650397241420093*^9, 3.650397269325005*^9}, {3.650397320160763*^9, 
   3.6503973728814907`*^9}, {3.650397557116136*^9, 3.650397563705247*^9}, {
   3.6503976938864927`*^9, 3.650397697449168*^9}, {3.650397736278656*^9, 
   3.650397775284513*^9}, {3.650398089837348*^9, 3.6503981035366163`*^9}, {
   3.650398221740559*^9, 3.650398222291196*^9}, 3.650398276048295*^9, 
   3.650398378918593*^9, 3.650398417880411*^9, {3.6503985231554947`*^9, 
   3.650398524638492*^9}, {3.650398564200754*^9, 3.650398595039349*^9}, {
   3.6503991594849567`*^9, 3.650399182644244*^9}, {3.650399213561988*^9, 
   3.650399241493946*^9}, {3.650457037611993*^9, 3.6504571327144938`*^9}, {
   3.650457848337199*^9, 3.65045784852353*^9}, {3.650457960202734*^9, 
   3.650457974973077*^9}, {3.650458105683634*^9, 3.650458107861598*^9}, {
   3.650458145902514*^9, 3.650458147195911*^9}, {3.6504582336780653`*^9, 
   3.650458241138446*^9}, 3.650458349344626*^9, {3.650458432501358*^9, 
   3.6504584350537252`*^9}, {3.650458520959674*^9, 3.6504585440390778`*^9}, {
   3.650458584907843*^9, 3.650458605319901*^9}, {3.6504587002888107`*^9, 
   3.650458711183077*^9}, {3.650458752254519*^9, 3.650458753382483*^9}, {
   3.650458796063044*^9, 3.650458821818866*^9}, {3.650458884843923*^9, 
   3.650458885360979*^9}, {3.650458927108613*^9, 3.650458927853345*^9}, {
   3.650458963398732*^9, 3.6504589647666616`*^9}, 3.650459016135778*^9, {
   3.6504591013968554`*^9, 3.6504591236633863`*^9}, {3.650459201155778*^9, 
   3.6504592433314667`*^9}, {3.650459328635944*^9, 3.650459343297324*^9}, {
   3.650459385590083*^9, 3.6504593861944103`*^9}, {3.650459431372368*^9, 
   3.6504594342594748`*^9}, {3.650459546422625*^9, 3.650459547053088*^9}, {
   3.650459956041194*^9, 3.650460049244746*^9}, {3.650460086318667*^9, 
   3.6504600955871897`*^9}, {3.650460150923061*^9, 3.650460157874569*^9}, {
   3.650460204818117*^9, 3.650460236320572*^9}, {3.650460274666914*^9, 
   3.650460319205895*^9}, 3.6504603662876*^9, {3.650460468476115*^9, 
   3.6504604688182373`*^9}, {3.650628453384241*^9, 3.650628551869013*^9}, {
   3.6506287428522263`*^9, 3.650628759552331*^9}, {3.650629461196892*^9, 
   3.650629529599924*^9}, {3.650629567913452*^9, 3.650629571093204*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1280, 685},
WindowMargins->{{-1603, Automatic}, {Automatic, -684}},
FrontEndVersion->"10.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (July 29, \
2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 106, 1, 64, "Section"],
Cell[CellGroupData[{
Cell[711, 27, 276, 3, 44, "Subsection"],
Cell[990, 32, 9578, 213, 301, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10605, 250, 228, 3, 44, "Subsection"],
Cell[10836, 255, 17906, 470, 828, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28779, 730, 111, 1, 44, "Subsection"],
Cell[28893, 733, 6481, 148, 420, "Input"],
Cell[CellGroupData[{
Cell[35399, 885, 13449, 295, 1015, "Input"],
Cell[48851, 1182, 149, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49037, 1190, 692, 14, 28, "Input"],
Cell[49732, 1206, 463, 9, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50244, 1221, 114, 1, 44, "Subsection"],
Cell[50361, 1224, 5873, 126, 216, "Input"],
Cell[56237, 1352, 6826, 144, 182, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
